<template>
  <highcharts
    :options="lineOptions"
  />
</template>

<script>
import '@/plugins/highcharts.js'
import {
  HEATING_COLOR,
  ELECTRICITY_COLOR,
  REFRIGERANTS_COLOR,
  VEHICLES_COLOR,
  TRAVELS_COLOR,
  COMMUTES_COLOR,
  COMPUTERDEVICES_COLOR,
  PURCHASES_COLOR
} from '@/models/definitions.js'

/* function addPointsBetween (twoPoints) {
  const newPoint = (twoPoints[0] + twoPoints[1]) / 2
  const threePoints = [twoPoints[0], newPoint, twoPoints[1]]
  return threePoints
} */

export default {
  name: 'TrajectoryChart',
  props: {
    ghgi: {
      type: Object,
      default: function () {
        return {}
      }
    },
    scenario: {
      type: Object,
      default: function () {
        return {}
      }
    },
    withContrails: {
      type: Boolean,
      default: true
    }
  },
  data () {
    return {
      lineOptions: {
        title: {
          text: ''
        },
        chart: {
          type: 'area'
        },
        plotOptions: {
          area: {
            stacking: 'normal'
          }
        },
        /* plotOptions: {
          series: {
            fillOpacity: 0.2
          }
        }, */
        credits: {
          enabled: false
        },
        tooltip: {
          valueSuffix: ' ' + this.$t('t.co2e'),
          valueDecimals: 2,
          shared: true
        },
        yAxis: {
          title: {
            text: this.$t('emissions.t.co2e')
          }
        },
        xAxis: {
          categories: [],
          maxPadding: 0,
          min: 0.45,
          max: 0.55
        },
        series: [],
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          }
        }
      }
    }
  },
  methods: {
    updateChartsOptions: function () {
      if (this.ghgi && this.scenario) {
        let gtravelsi = this.ghgi.emissions.travels.intensity.intensity / 1000
        let stravelsi = this.scenario['ghgi'].emissions.travels.intensity.intensity / 1000
        if (this.withContrails) {
          gtravelsi = this.ghgi.emissions.travels.intensity.intensitywc / 1000
          stravelsi = this.scenario['ghgi'].emissions.travels.intensity.intensitywc / 1000
        }
        this.lineOptions.series = [{
          name: this.$t('travels'),
          data: [
            gtravelsi,
            stravelsi
          ],
          color: TRAVELS_COLOR
        }, {
          name: this.$t('vehicles'),
          data: [
            this.ghgi.emissions.vehicles.intensity.intensity / 1000,
            this.scenario['ghgi'].emissions.vehicles.intensity.intensity / 1000
          ],
          color: VEHICLES_COLOR
        }, {
          name: this.$t('commutes'),
          data: [
            this.ghgi.emissions.commutes.intensity.intensity / 1000,
            this.scenario['ghgi'].emissions.commutes.intensity.intensity / 1000
          ],
          color: COMMUTES_COLOR
        }, {
          name: this.$t('heating'),
          data: [
            this.ghgi.emissions.buildings.heatings.intensity.intensity / 1000,
            this.scenario['ghgi'].emissions.buildings.heatings.intensity.intensity / 1000
          ],
          color: HEATING_COLOR
        }, {
          name: this.$t('electricity'),
          data: [
            this.ghgi.emissions.buildings.electricity.intensity / 1000,
            this.scenario['ghgi'].emissions.buildings.electricity.intensity / 1000
          ],
          color: ELECTRICITY_COLOR
        }, {
          name: this.$t('refrigerants'),
          data: [
            this.ghgi.emissions.buildings.refrigerants.intensity / 1000,
            this.scenario['ghgi'].emissions.buildings.refrigerants.intensity / 1000
          ],
          color: REFRIGERANTS_COLOR
        }, {
          name: this.$t('computer.devices'),
          data: [
            this.ghgi.emissions.devices.intensity.intensity / 1000,
            this.scenario['ghgi'].emissions.devices.intensity.intensity / 1000
          ],
          color: COMPUTERDEVICES_COLOR
        }, {
          name: this.$t('purchases'),
          data: [
            this.ghgi.emissions.purchases.intensity.intensity / 1000,
            this.scenario['ghgi'].emissions.purchases.intensity.intensity / 1000
          ],
          color: PURCHASES_COLOR
        }]
        // add intermediate points
        /* this.lineOptions.series.map(serie => {
          let newData = addPointsBetween([serie.data[0], serie.data[1]])
          serie.data = newData
        }) */
        this.lineOptions.xAxis.categories = [this.ghgi.year, this.scenario.name]
      }
    }
  },
  watch: {
    '$i18n.locale': function () {
      this.updateChartsOptions()
    },
    ghgi: function () {
      this.updateChartsOptions()
    },
    scenario: function () {
      this.updateChartsOptions()
    },
    withContrails: function () {
      this.updateChartsOptions()
    }
  },
  mounted () {
    this.updateChartsOptions()
  }
}
</script>
